Module javafx.controls
Package javafx.scene.control.cell

# Class CheckBoxTableCell<S,T>

java.lang.Object
javafx.scene.Node
javafx.scene.Parent
javafx.scene.layout.Region
javafx.scene.control.Control
javafx.scene.control.Labeled
javafx.scene.control.Cell<T>
javafx.scene.control.IndexedCell<T>
javafx.scene.control.TableCell<S,T>
javafx.scene.control.cell.CheckBoxTableCell<S,T>

Type Parameters:
  `T` - The type of the elements contained within the TableColumn.

All Implemented Interfaces:
  `Styleable`, `EventTarget`, `Skinnable`

public class CheckBoxTableCell<S,T> extends TableCell<S,T>
A class containing a `TableCell` implementation that draws a `CheckBox` node inside the cell, optionally with a label to indicate what the checkbox represents.

By default, the CheckBoxTableCell is rendered with a CheckBox centred in the TableColumn. If a label is required, it is necessary to provide a non-null StringConverter instance to the `CheckBoxTableCell(Callback, StringConverter)` constructor.

To construct an instance of this class, it is necessary to provide a `Callback` that, given an object of type T, will return an `ObservableProperty<Boolean>` that represents whether the given item is selected or not. This ObservableValue will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the ObservableValue, if it changes externally).

Note that the CheckBoxTableCell renders the CheckBox 'live', meaning that the CheckBox is always interactive and can be directly toggled by the user. This means that it is not necessary that the cell enter its `editing state` (usually by the user double-clicking on the cell). A side-effect of this is that the usual editing callbacks (such as `on edit commit`) will not be called. If you want to be notified of changes, it is recommended to directly observe the boolean properties that are manipulated by the CheckBox.

Since:
  JavaFX 2.2

## Property Summary

Properties
Type
Property
Description
`final ObjectProperty<StringConverter<T>>`
`converter`
The `StringConverter` property.
`final ObjectProperty<Callback<Integer,ObservableValue<Boolean>>>`
`selectedStateCallback`
Property representing the `Callback` that is bound to by the CheckBox shown on screen.

### Properties inherited from class javafx.scene.control.TableCell

`tableColumn, tableRow, tableView`

### Properties inherited from class javafx.scene.control.IndexedCell

`index`

### Properties inherited from class javafx.scene.control.Cell

`editable, editing, empty, item, selected`

### Properties inherited from class javafx.scene.control.Labeled

`alignment, contentDisplay, ellipsisString, font, graphic, graphicTextGap, labelPadding, lineSpacing, mnemonicParsing, textAlignment, textFill, textOverrun, text, underline, wrapText`

### Properties inherited from class javafx.scene.control.Control

`contextMenu, skin, tooltip`

### Properties inherited from class javafx.scene.layout.Region

`background, border, cacheShape, centerShape, height, insets, maxHeight, maxWidth, minHeight, minWidth, opaqueInsets, padding, prefHeight, prefWidth, scaleShape, shape, snapToPixel, width`

### Properties inherited from class javafx.scene.Parent

`needsLayout`

### Properties inherited from class javafx.scene.Node

`accessibleHelp, accessibleRoleDescription, accessibleRole, accessibleText, blendMode, boundsInLocal, boundsInParent, cacheHint, cache, clip, cursor, depthTest, disabled, disable, effectiveNodeOrientation, effect, eventDispatcher, focused, focusTraversable, hover, id, inputMethodRequests, layoutBounds, layoutX, layoutY, localToParentTransform, localToSceneTransform, managed, mouseTransparent, nodeOrientation, onContextMenuRequested, onDragDetected, onDragDone, onDragDropped, onDragEntered, onDragExited, onDragOver, onInputMethodTextChanged, onKeyPressed, onKeyReleased, onKeyTyped, onMouseClicked, onMouseDragEntered, onMouseDragExited, onMouseDragged, onMouseDragOver, onMouseDragReleased, onMouseEntered, onMouseExited, onMouseMoved, onMousePressed, onMouseReleased, onRotate, onRotationFinished, onRotationStarted, onScrollFinished, onScroll, onScrollStarted, onSwipeDown, onSwipeLeft, onSwipeRight, onSwipeUp, onTouchMoved, onTouchPressed, onTouchReleased, onTouchStationary, onZoomFinished, onZoom, onZoomStarted, opacity, parent, pickOnBounds, pressed, rotate, rotationAxis, scaleX, scaleY, scaleZ, scene, style, translateX, translateY, translateZ, viewOrder, visible`

## Field Summary

### Fields inherited from class javafx.scene.layout.Region

`USE_COMPUTED_SIZE, USE_PREF_SIZE`

### Fields inherited from class javafx.scene.Node

`BASELINE_OFFSET_SAME_AS_HEIGHT`

## Constructor Summary

Constructors
Constructor
Description
`CheckBoxTableCell()`
Creates a default CheckBoxTableCell.
`CheckBoxTableCell(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty)`
Creates a default CheckBoxTableCell with a custom `Callback` to retrieve an ObservableValue for a given cell index.
`CheckBoxTableCell(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty, StringConverter<T> converter)`
Creates a CheckBoxTableCell with a custom string converter.

## Method Summary

Modifier and Type
Method
Description
`final ObjectProperty<StringConverter<T>>`
`converterProperty()`
The `StringConverter` property.
`static <S> Callback<TableColumn<S,Boolean>,TableCell<S,Boolean>>`
`forTableColumn(TableColumn<S,Boolean> column)`
Creates a cell factory for use in a `TableColumn` cell factory.
`static <S, T> Callback<TableColumn<S,T>,TableCell<S,T>>`
`forTableColumn(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty)`
Creates a cell factory for use in a `TableColumn` cell factory.
`static <S, T> Callback<TableColumn<S,T>,TableCell<S,T>>`
`forTableColumn(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty, boolean showLabel)`
Creates a cell factory for use in a `TableColumn` cell factory.
`static <S, T> Callback<TableColumn<S,T>,TableCell<S,T>>`
`forTableColumn(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty, StringConverter<T> converter)`
Creates a cell factory for use in a `TableColumn` cell factory.
`final StringConverter<T>`
`getConverter()`
Returns the `StringConverter` used in this cell.
`final Callback<Integer,ObservableValue<Boolean>>`
`getSelectedStateCallback()`
Returns the `Callback` that is bound to by the CheckBox shown on screen.
`final ObjectProperty<Callback<Integer,ObservableValue<Boolean>>>`
`selectedStateCallbackProperty()`
Property representing the `Callback` that is bound to by the CheckBox shown on screen.
`final void`
`setConverter(StringConverter<T> value)`
Sets the `StringConverter` to be used in this cell.
`final void`
`setSelectedStateCallback(Callback<Integer,ObservableValue<Boolean>> value)`
Sets the `Callback` that is bound to by the CheckBox shown on screen.
`void`
`updateItem(T item, boolean empty)`
The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell.

### Methods inherited from class javafx.scene.control.TableCell

`cancelEdit, commitEdit, createDefaultSkin, executeAccessibleAction, getTableColumn, getTableRow, getTableView, layoutChildren, queryAccessibleAttribute, startEdit, tableColumnProperty, tableRowProperty, tableViewProperty, updateSelected, updateTableColumn, updateTableRow, updateTableView`

### Methods inherited from class javafx.scene.control.IndexedCell

`getIndex, indexProperty, updateIndex`

### Methods inherited from class javafx.scene.control.Cell

`editableProperty, editingProperty, emptyProperty, getInitialFocusTraversable, getItem, isEditable, isEditing, isEmpty, isItemChanged, isSelected, itemProperty, selectedProperty, setEditable, setItem`

### Methods inherited from class javafx.scene.control.Labeled

`alignmentProperty, contentDisplayProperty, ellipsisStringProperty, fontProperty, getAlignment, getClassCssMetaData, getContentBias, getContentDisplay, getControlCssMetaData, getEllipsisString, getFont, getGraphic, getGraphicTextGap, getInitialAlignment, getLabelPadding, getLineSpacing, getText, getTextAlignment, getTextFill, getTextOverrun, graphicProperty, graphicTextGapProperty, isMnemonicParsing, isUnderline, isWrapText, labelPaddingProperty, lineSpacingProperty, mnemonicParsingProperty, setAlignment, setContentDisplay, setEllipsisString, setFont, setGraphic, setGraphicTextGap, setLineSpacing, setMnemonicParsing, setText, setTextAlignment, setTextFill, setTextOverrun, setUnderline, setWrapText, textAlignmentProperty, textFillProperty, textOverrunProperty, textProperty, toString, underlineProperty, wrapTextProperty`

### Methods inherited from class javafx.scene.control.Control

`computeMaxHeight, computeMaxWidth, computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, contextMenuProperty, getBaselineOffset, getContextMenu, getCssMetaData, getSkin, getTooltip, isResizable, setContextMenu, setSkin, setTooltip, skinProperty, tooltipProperty`

### Methods inherited from class javafx.scene.layout.Region

`backgroundProperty, borderProperty, cacheShapeProperty, centerShapeProperty, getBackground, getBorder, getHeight, getInsets, getMaxHeight, getMaxWidth, getMinHeight, getMinWidth, getOpaqueInsets, getPadding, getPrefHeight, getPrefWidth, getShape, getUserAgentStylesheet, getWidth, heightProperty, insetsProperty, isCacheShape, isCenterShape, isScaleShape, isSnapToPixel, layoutInArea, layoutInArea, layoutInArea, layoutInArea, maxHeight, maxHeightProperty, maxWidth, maxWidthProperty, minHeight, minHeightProperty, minWidth, minWidthProperty, opaqueInsetsProperty, paddingProperty, positionInArea, positionInArea, prefHeight, prefHeightProperty, prefWidth, prefWidthProperty, resize, scaleShapeProperty, setBackground, setBorder, setCacheShape, setCenterShape, setHeight, setMaxHeight, setMaxSize, setMaxWidth, setMinHeight, setMinSize, setMinWidth, setOpaqueInsets, setPadding, setPrefHeight, setPrefSize, setPrefWidth, setScaleShape, setShape, setSnapToPixel, setWidth, shapeProperty, snappedBottomInset, snappedLeftInset, snappedRightInset, snappedTopInset, snapPosition, snapPositionX, snapPositionY, snapSize, snapSizeX, snapSizeY, snapSpace, snapSpaceX, snapSpaceY, snapToPixelProperty, widthProperty`

### Methods inherited from class javafx.scene.Parent

`getChildren, getChildrenUnmodifiable, getManagedChildren, getStylesheets, isNeedsLayout, layout, lookup, needsLayoutProperty, requestLayout, requestParentLayout, setNeedsLayout, updateBounds`

### Methods inherited from class javafx.scene.Node

`accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClip, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInitialCursor, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, getViewOrder, hasProperties, hoverProperty, idProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setViewOrder, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, translateXProperty, translateYProperty, translateZProperty, usesMirroring, viewOrderProperty, visibleProperty`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Methods inherited from interface javafx.css.Styleable

`getStyleableNode`

## Property Details

### converter

public final ObjectProperty<StringConverter<T>> converterProperty
The `StringConverter` property.

See Also:
  - `converterProperty()`

### selectedStateCallback

public final ObjectProperty<Callback<Integer,ObservableValue<Boolean>>> selectedStateCallbackProperty
Property representing the `Callback` that is bound to by the CheckBox shown on screen.

See Also:
  - `getSelectedStateCallback()`
  - `setSelectedStateCallback(Callback)`
  - `selectedStateCallbackProperty()`

## Constructor Details

### CheckBoxTableCell

public CheckBoxTableCell()
Creates a default CheckBoxTableCell.

### CheckBoxTableCell

public CheckBoxTableCell(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty)
Creates a default CheckBoxTableCell with a custom `Callback` to retrieve an ObservableValue for a given cell index.

Parameters:
  `getSelectedProperty` - A `Callback` that will return an `ObservableValue` given an index from the TableColumn.

### CheckBoxTableCell

public CheckBoxTableCell(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty, StringConverter<T> converter)
Creates a CheckBoxTableCell with a custom string converter.

Parameters:
  `getSelectedProperty` - A `Callback` that will return a `ObservableValue` given an index from the TableColumn.
  `converter` - A StringConverter that, given an object of type T, will return a String that can be used to represent the object visually.

## Method Details

### forTableColumn

public static <S> Callback<TableColumn<S,Boolean>,TableCell<S,Boolean>> forTableColumn(TableColumn<S,Boolean> column)
Creates a cell factory for use in a `TableColumn` cell factory. This method requires that the TableColumn be of type `Boolean`.

When used in a TableColumn, the CheckBoxCell is rendered with a CheckBox centered in the column.

The `ObservableValue<Boolean>` contained within each cell in the column will be bound bidirectionally. This means that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).

Type Parameters:
  `S` - The type of the TableView generic type
Parameters:
  `column` - The TableColumn of type Boolean
Returns:
  A `Callback` that will return a `TableCell` that is able to work on the type of element contained within the TableColumn.

### forTableColumn

public static <S, T> Callback<TableColumn<S,T>,TableCell<S,T>> forTableColumn(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty)
Creates a cell factory for use in a `TableColumn` cell factory. This method requires that the TableColumn be of type `ObservableValue<Boolean>`.

When used in a TableColumn, the CheckBoxCell is rendered with a CheckBox centered in the column.

Type Parameters:
  `S` - The type of the TableView generic type
  `T` - The type of the elements contained within the `TableColumn` instance.
Parameters:
  `getSelectedProperty` - A Callback that, given an object of type `TableColumn<S,T>`, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).
Returns:
  A `Callback` that will return a `TableCell` that is able to work on the type of element contained within the TableColumn.

### forTableColumn

public static <S, T> Callback<TableColumn<S,T>,TableCell<S,T>> forTableColumn(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty, boolean showLabel)
Creates a cell factory for use in a `TableColumn` cell factory. This method requires that the TableColumn be of type `ObservableValue<Boolean>`.

When used in a TableColumn, the CheckBoxCell is rendered with a CheckBox centered in the column.

Type Parameters:
  `S` - The type of the TableView generic type
  `T` - The type of the elements contained within the `TableColumn` instance.
Parameters:
  `getSelectedProperty` - A Callback that, given an object of type `TableColumn<S,T>`, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).
  `showLabel` - In some cases, it may be desirable to show a label in the TableCell beside the `CheckBox`. By default a label is not shown, but by setting this to true the item in the cell will also have toString() called on it. If this is not the desired behavior, consider using `forTableColumn(javafx.util.Callback, javafx.util.StringConverter)`, which allows for you to provide a callback that specifies the label for a given row item.
Returns:
  A `Callback` that will return a `TableCell` that is able to work on the type of element contained within the TableColumn.

### forTableColumn

public static <S, T> Callback<TableColumn<S,T>,TableCell<S,T>> forTableColumn(Callback<Integer,ObservableValue<Boolean>> getSelectedProperty, StringConverter<T> converter)
Creates a cell factory for use in a `TableColumn` cell factory. This method requires that the TableColumn be of type `ObservableValue<Boolean>`.

When used in a TableColumn, the CheckBoxCell is rendered with a CheckBox centered in the column.

Type Parameters:
  `S` - The type of the TableView generic type
  `T` - The type of the elements contained within the `TableColumn` instance.
Parameters:
  `getSelectedProperty` - A Callback that, given an object of type `TableColumn<S,T>`, will return an `ObservableValue<Boolean>` that represents whether the given item is selected or not. This `ObservableValue<Boolean>` will be bound bidirectionally (meaning that the CheckBox in the cell will set/unset this property based on user interactions, and the CheckBox will reflect the state of the `ObservableValue<Boolean>`, if it changes externally).
  `converter` - A StringConverter that, give an object of type T, will return a String that can be used to represent the object visually. The default implementation in `forTableColumn(Callback, boolean)` (when showLabel is true) is to simply call .toString() on all non-null items (and to just return an empty string in cases where the given item is null).
Returns:
  A `Callback` that will return a `TableCell` that is able to work on the type of element contained within the TableColumn.

### converterProperty

public final ObjectProperty<StringConverter<T>> converterProperty()
The `StringConverter` property.

Returns:
  the `StringConverter` property

### setConverter

public final void setConverter(StringConverter<T> value)
Sets the `StringConverter` to be used in this cell.

Parameters:
  `value` - the `StringConverter` to be used in this cell

### getConverter

public final StringConverter<T> getConverter()
Returns the `StringConverter` used in this cell.

Returns:
  the `StringConverter` used in this cell

### selectedStateCallbackProperty

public final ObjectProperty<Callback<Integer,ObservableValue<Boolean>>> selectedStateCallbackProperty()
Property representing the `Callback` that is bound to by the CheckBox shown on screen.

Returns:
  the property representing the `Callback` that is bound to by the CheckBox shown on screen
See Also:
  - `getSelectedStateCallback()`
  - `setSelectedStateCallback(Callback)`

### setSelectedStateCallback

public final void setSelectedStateCallback(Callback<Integer,ObservableValue<Boolean>> value)
Sets the `Callback` that is bound to by the CheckBox shown on screen.

Parameters:
  `value` - the `Callback` that is bound to by the CheckBox shown on screen

### getSelectedStateCallback

public final Callback<Integer,ObservableValue<Boolean>> getSelectedStateCallback()
Returns the `Callback` that is bound to by the CheckBox shown on screen.

Returns:
  the `Callback` that is bound to by the CheckBox shown on screen

### updateItem

public void updateItem(T item, boolean empty)
The updateItem method should not be called by developers, but it is the best method for developers to override to allow for them to customise the visuals of the cell. To clarify, developers should never call this method in their code (they should leave it up to the UI control, such as the `ListView` control) to call this method. However, the purpose of having the updateItem method is so that developers, when specifying custom cell factories (again, like the ListView `cell factory`), the updateItem method can be overridden to allow for complete customisation of the cell.

It is very important that subclasses of Cell override the updateItem method properly, as failure to do so will lead to issues such as blank cells or cells with unexpected content appearing within them. Here is an example of how to properly override the updateItem method:

     protected void updateItem(T item, boolean empty) {
         super.updateItem(item, empty);

         if (empty || item == null) {
             setText(null);
             setGraphic(null);
         } else {
             setText(item.toString());
         }
     }

Note in this code sample two important points:

1. We call the super.updateItem(T, boolean) method. If this is not done, the item and empty properties are not correctly set, and you are likely to end up with graphical issues.
2. We test for the `empty` condition, and if true, we set the text and graphic properties to null. If we do not do this, it is almost guaranteed that end users will see graphical artifacts in cells unexpectedly.

Overrides:
  `updateItem` in class `Cell<T>`
Parameters:
  `item` - The new item for the cell.
  `empty` - whether or not this cell represents data from the list. If it is empty, then it does not represent any domain data, but is a cell being used to render an "empty" row.